/*!-----------------------------------------------------------------------------
 * A jQuery plugin that creates events when a certain DOM element is in a position relative to a selected portion of the viewport.
 * v2.3.3 - built 2021-14-05
 * Licensed under the MIT License.
 * https://github.com/DonnieRich/standoutjs
 * ----------------------------------------------------------------------------
 * Copyright (C) 2020-2021 Donato Pasquale Riccio
 * https://designaddicted.eu/
 * --------------------------------------------------------------------------*/
!function(t){"function"==typeof define&&define.amd?define(["jquery"],t):"object"==typeof module&&module.exports?module.exports=function(e,o){return void 0===o&&(o="undefined"!=typeof window?require("jquery"):require("jquery")(e)),t(o),o}:t(jQuery)}(function(t,e,o,i){"use strict";const n="standout";let s=!1;const r=[],l={onlyFirstTime:!1,oncePerEvent:!0,showDemoLayout:!1,lightBoxEffect:!1,backgroundColor:"#000000",top:.3,bottom:.3,overlay:{backgroundColor:"#000000",opacity:"0",width:"100%",height:"100%",position:"fixed",top:"0",left:"0",zIndex:"9999",display:"none"},overlayId:"overlayStandout",enabled:!0},p={onlyFirstTime:!1,oncePerEvent:!1},h={initialized:!1,originalTop:0,originalLeft:0,elementWidth:0,elementHeight:0,elementTop:0,elementCenter:0,elementBottom:0,elementTopPosition:0,elementCenterPosition:0,elementBottomPosition:0,viewportHeight:0,viewportTop:0,viewportBottom:0,lastViewportTop:0,lastEvent:"",currentEvent:"",eventsQueue:[],maxEventsInQueue:7},m={backgroundColor:"#000000",opacity:"0.75",width:"100%",position:"fixed",top:"0",left:"0",zIndex:"9999"},a={backgroundColor:"#000000",opacity:"0.75",width:"100%",position:"fixed",left:"0",zIndex:"9999",height:"5px",transform:"translateY(-50%)"},d={backgroundColor:"#000000",opacity:"0.75",width:"100%",position:"fixed",bottom:"0",left:"0",zIndex:"9999"};function Standout(t,e,o,i){this._name=n,this.i=e,this.idx=`standout_${this.i}`,this.clonedId=`${this.idx}_cloned`,this.isLastElement=i,this.options=this._getOptions(o),this.element=t,this.enabled=this.options.enabled,r[e]=this,this._init()}t.extend(Standout.prototype,{_init(){this._buildCache(),this._bindEvents(),this.options.showDemoLayout&&!s&&(s=!0,this._setDemoLayout(this.options)),this.options.lightBoxEffect&&(0===t(`#${this.options.overlayId}`).length&&this._setOverlayLayout(this.options),0===t(`.${this.clonedId}`).length&&this._duplicateElement(this.element,this.clonedId),this.options.compatibility&&this.isLastElement&&"function"==typeof this.options.dynamicContentListeners&&this.options._dynamicContentListeners(),this._registerLightboxEvents())},_buildCache(){this.$element=this._getElement(this.i)},_bindEvents(){const o=this;t(e).on("resize scroll",(function(){o._initObj(),o._updateObj(),o._isInViewport()?(o._setCurrentEvent(),(!o.options.oncePerEvent||o.options.onlyFirstTime&&o.options.oncePerEvent&&!o._checkIfEventAlreadyTriggered()||o.options.oncePerEvent&&!o.options.onlyFirstTime&&!o._checkIfLastEvent())&&o.$element.trigger(o.$element.objProps.currentEvent,[o]),o._setLastEvent(),o._addEventToQueue()):o._resetEvents()}))},_isInViewport(){return this.$element.objProps.elementBottom>this.$element.objProps.viewportTop&&this.$element.objProps.elementTop<this.$element.objProps.viewportBottom&&this.$element.objProps.initialized},_setCurrentEvent(){const t=this.$element.objProps;let e="U";0===t.lastViewportTop&&(t.lastViewportTop=t.viewportTop),t.elementCenterPosition>=t.viewportTopLimit&&t.elementCenterPosition<=t.viewportBottomLimit?e="C":t.elementBottomPosition<t.viewportTopLimit?e="O":t.elementBottomPosition>t.viewportTopLimit&&t.elementCenterPosition<t.viewportTopLimit?e=t.viewportTop<t.lastViewportTop?"ET":"EXT":t.elementTopPosition<t.viewportBottomLimit&&t.elementCenterPosition>t.viewportBottomLimit&&(e=t.viewportTop>t.lastViewportTop?"EB":"EXB"),t.lastViewportTop=t.viewportTop,t.currentEvent=e},_getCurrentEvent(){return this.$element.objProps.currentEvent},_setLastEvent(){this.$element.objProps.lastEvent=this.$element.objProps.currentEvent},_getLastEvent(){return this.$element.objProps.lastEvent},_getViewportBottomLimit(){return this.$element.objProps.viewportBottomLimit},_getViewportTopLimit(){return this.$element.objProps.viewportTopLimit},_getElementCenterPosition(){return this.$element.objProps.elementCenterPosition},_getElementHeight(){return this.$element.objProps.elementHeight},_checkIfLastEvent(){return this._getLastEvent()===this._getCurrentEvent()},_checkIfEventAlreadyTriggered(){return this.$element.objProps.eventsQueue.includes(this._getCurrentEvent())},_addEventToQueue(){this._checkIfEventAlreadyTriggered()||this.$element.objProps.eventsQueue.push(this._getCurrentEvent())},_resetEvents(){this.$element.objProps.lastEvent="",this.$element.objProps.currentEvent=""},_initObj(){this.$element.objProps.originalTop=this.$element.offset().top,this.$element.objProps.originalLeft=this.$element.offset().left,this.$element.objProps.initialized=!0},_updateObj(){const o=this.$element.objProps;o.initialized=!0,o.elementWidth=this.$element.width(),o.elementHeight=this.$element.outerHeight(),o.elementTop=this.$element.offset().top,o.elementCenter=o.elementTop+o.elementHeight/2,o.elementBottom=o.elementTop+o.elementHeight,o.viewportHeight=t(e).height(),o.viewportTop=t(e).scrollTop(),o.viewportBottom=o.viewportTop+t(e).height(),o.viewportTopLimit=o.viewportHeight*this.options.top,o.viewportBottomLimit=o.viewportHeight-o.viewportHeight*this.options.bottom,o.viewportCenterLimit=o.viewportTopLimit+o.viewportHeight*(1-(this.options.top+this.options.bottom))*.5,o.elementTopPosition=o.elementTop-o.viewportTop,o.elementCenterPosition=o.elementTopPosition+o.elementHeight/2,o.elementBottomPosition=o.elementTopPosition+o.elementHeight},_calculateOpacityValue(t){const e=this._getElementHeight()/2;return(e-Math.abs(t-this._getElementCenterPosition()))/e},_getCurrentElementOpacity(){let t=0;switch(this._getCurrentEvent()){case"C":t=1;break;case"EB":case"EXB":t=this._calculateOpacityValue(this._getViewportBottomLimit());break;case"ET":case"EXT":t=this._calculateOpacityValue(this._getViewportTopLimit())}return t.toFixed(2)},_getPrevNextElementOpacity(){let t=0,e=0,o=0;const i=this._getNextElement(this.i),n=this._getPrevElement(this.i);return t=this._getCurrentElementOpacity(),void 0!==i&&i.$element.hasOwnProperty("objProps")&&(e=i._getCurrentElementOpacity()),void 0!==n&&n.$element.hasOwnProperty("objProps")&&(o=n._getCurrentElementOpacity()),Math.max(t,e,o)},_registerLightboxEvents(){const t=this;t.$element.on("EB EXB ET EXT O  U C",(function(){return t._fading()}))},_fading(){const e=this.$element.objProps,o=this._getPrevNextElementOpacity();t("#overlayStandout").css({display:"block",opacity:o<.75?o:.75}),t(`.${this.clonedId}`).css({display:"block",position:"absolute",top:e.originalTop,left:e.originalLeft,"z-index":"10000",width:e.elementWidth,height:e.elementHeight,margin:"0",opacity:this._getCurrentElementOpacity()<1?this._getCurrentElementOpacity():1})},_getOptions:e=>e.lightBoxEffect?t.extend({},l,e,p):t.extend({},l,e),_getElement(e){let o=!1;return void 0!==r[e]&&e>-1&&e<r.length&&(o=t(r[e].element),o.objProps=t.extend({},h)),o},_getNextElement:t=>r[t+1],_getPrevElement:t=>r[t-1],_setDemoLayout(e){let o=t("<div />").css(m).css("height",`calc(100vh * ${e.top})`).attr("id","demoLayoutTop");t("body").append(o),o=t("<div />").css(a).css("top",`calc(100vh * ${e.top} + (100vh - (100vh * ${e.top} + 100vh * ${e.bottom})) / 2)`),t("body").append(o),o=t("<div />").css(d).css("height",`calc(100vh * ${e.bottom})`).attr("id","demoLayoutBottom"),t("body").append(o)},_setOverlayLayout(e){const o=t("<div />").css(e.overlay).attr("id",e.overlayId);t("body").append(o)},_duplicateElement(e,o){t(e).clone(!0,!0).addClass(o).css("display","none").appendTo("body")}}),t.fn.standout=function(e){if(undefined===e||"object"==typeof e){const o=this,i=o.length-1;return this.each((function(n){t.data(this,"plugin_standout")||t.data(this,"plugin_standout",new Standout(o[n],n,e,n===i))}))}"string"==typeof e&&"_"!==e[0]&&"init"!==e?"destroy"===e&&t.data(this,"plugin_standout",null):console.log("No public method available")}}(jQuery,window,document));
//# sourceMappingURL=standout.min.js.map
